<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <!--<meta http-equiv="X-UA-Compatible" content="ie=edge">-->
    <title>Document</title>
</head>
<body>
<div style="padding: 20px;">
    <h1>S3 app</h1>
    <form action="" method="post" enctype="multipart/form-data">
        <label for="file" style="margin-bottom: 10px; display: block;">Change photo (only JPEG and PNG is
            allowed)</label>
        <input id="file" name="file" type="file">
    </form>
</div>
<script>
    const input = document.getElementById('file');
    // Event handler executed when a file is selected
    const onSelectFile = () => {
        if (input.files) {
            send(input.files[0]);
        }
    };

    // Add a listener on your input
    // It will be triggered when a file will be selected
    input.addEventListener('change', onSelectFile, false);

    const send = (file) => {
        const body = {
            name: file.name,
            type: file.type
        };
        fetch('http://localhost:8000/getUploadUrl', { // Your POST endpoint
            method: 'POST',
            headers: {
                "Content-Type": "application/json"
            },
            body: JSON.stringify(body) // This is your file object
        }).then(
            response => response.json() // if the response is a JSON object
        ).then(
            data => upload(data, file) // Handle the success response object
        ).catch(
            error => console.log(error) // Handle the error response object
        );
    };

    const upload = (data, file) => {
        const form = new FormData();
        Object.keys(data.fields).forEach((key) => {
            form.append(key, data.fields[key]);
        });
        form.append('file', file);

        fetch(data.url, {
            method: 'POST',
            body: form
        }).then(
            response => alert('upload success!')
        ).catch(
            error => console.log(error) // Handle the error response object
        );
    };
</script>
</body>
</html>